import Foundation

// Function Composition in Swift

precedencegroup Group { associativity: left }
infix operator >>>: Group
func >>> <A, B, C>(_ lhs: @escaping (A) -> B,
                   _ rhs: @escaping (B) -> C) -> (A) -> C {
    return { rhs(lhs($0)) }
}

func square(_ x: Int) -> Int {
    return x * x
}

func increment(_ x: Int) -> Int {
    return x + 1
}

func half(_ x: Int) -> Int {
    return x / 2
}

func describe(_ val: CustomStringConvertible) -> String {
    return "The resulting value is: \(val)"
}

describe(increment(square(half(6))))
(half >>> square >>> increment >>> describe)(6)

